'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _mergeConfigs = require('../merge-configs');

var _mergeConfigs2 = _interopRequireDefault(_mergeConfigs);

var _graphCrdt = require('graph-crdt');

var _context3 = require('./context');

var _context4 = _interopRequireDefault(_context3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = (0, _symbol2.default)('database configuration');

/**
 * Plugin manager for graph-crdt.
 * @class Database
 */

var Database = function (_Graph) {
  (0, _inherits3.default)(Database, _Graph);

  /**
   * Instantiates a new graph database.
   * @param  {Object} config - A database configuration object.
   */
  function Database(config) {
    (0, _classCallCheck3.default)(this, Database);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Database.__proto__ || (0, _getPrototypeOf2.default)(Database)).call(this));

    _this[settings] = config;
    return _this;
  }

  /**
   * Merges a node into the graph.
   * @param  {String} uid - The unique ID of the node.
   * @param  {Object} value - The fields to add/update.
   * @return {Context} - Resolves to the context written.
   */


  (0, _createClass3.default)(Database, [{
    key: 'write',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(uid, value) {
        var node, update, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, store;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                node = new _context4.default(this, { uid: uid });


                node.merge(value);

                this.merge((0, _defineProperty3.default)({}, uid, node));

                update = _graphCrdt.Graph.source((0, _defineProperty3.default)({}, uid, this.value(uid)));

                /** Persist the change. */

                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 7;
                _iterator = (0, _getIterator3.default)(this[settings].storage);

              case 9:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 16;
                  break;
                }

                store = _step.value;
                _context.next = 13;
                return store.write(update);

              case 13:
                _iteratorNormalCompletion = true;
                _context.next = 9;
                break;

              case 16:
                _context.next = 22;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context['catch'](7);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 22:
                _context.prev = 22;
                _context.prev = 23;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 25:
                _context.prev = 25;

                if (!_didIteratorError) {
                  _context.next = 28;
                  break;
                }

                throw _iteratorError;

              case 28:
                return _context.finish(25);

              case 29:
                return _context.finish(22);

              case 30:
                return _context.abrupt('return', this.value(uid));

              case 31:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[7, 18, 22, 30], [23,, 25, 29]]);
      }));

      function write(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return write;
    }()

    /**
     * Read a context from the database.
     * @param  {String} uid - The node's unique ID.
     * @return {Context|undefined} - Resolves to the node.
     */

  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(uid) {
        var cached, node, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, store, result, update;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                cached = this.value(uid);

                if (!cached) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt('return', cached);

              case 3:
                node = null;

                // Ask the storage plugins for it.

                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context2.prev = 7;
                _iterator2 = (0, _getIterator3.default)(this[settings].storage);

              case 9:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context2.next = 19;
                  break;
                }

                store = _step2.value;
                _context2.next = 13;
                return store.read(uid);

              case 13:
                result = _context2.sent;
                update = _graphCrdt.Node.source(result);

                if (result) {
                  node = node || new _context4.default(this, { uid: uid });
                  node.merge(update);
                }

              case 16:
                _iteratorNormalCompletion2 = true;
                _context2.next = 9;
                break;

              case 19:
                _context2.next = 25;
                break;

              case 21:
                _context2.prev = 21;
                _context2.t0 = _context2['catch'](7);
                _didIteratorError2 = true;
                _iteratorError2 = _context2.t0;

              case 25:
                _context2.prev = 25;
                _context2.prev = 26;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 28:
                _context2.prev = 28;

                if (!_didIteratorError2) {
                  _context2.next = 31;
                  break;
                }

                throw _iteratorError2;

              case 31:
                return _context2.finish(28);

              case 32:
                return _context2.finish(25);

              case 33:

                // Cache the value.
                if (node) {
                  this.merge((0, _defineProperty3.default)({}, uid, node));
                }

                return _context2.abrupt('return', node);

              case 35:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[7, 21, 25, 33], [26,, 28, 32]]);
      }));

      function read(_x3) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()
  }]);
  return Database;
}(_graphCrdt.Graph);

/**
 * Creates a new instance of `Database` with or without `new`.
 * @param  {...Object} configs - Plugins and configurations for the database.
 * @return {Database} - A new database instance.
 */


function database() {
  for (var _len = arguments.length, configs = Array(_len), _key = 0; _key < _len; _key++) {
    configs[_key] = arguments[_key];
  }

  var config = (0, _mergeConfigs2.default)(configs);

  return new Database(config);
}

database.configuration = settings;

exports.default = database;