'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _graphCrdt = require('graph-crdt');

var _index = require('../../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Simple storage mock.
var Storage = function () {
  function Storage() {
    (0, _classCallCheck3.default)(this, Storage);

    this.cache = {};
  }

  (0, _createClass3.default)(Storage, [{
    key: 'write',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(graph) {
        var cache, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, uid, node;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                cache = this.cache;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 4;


                for (_iterator = (0, _getIterator3.default)(graph); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  _step$value = (0, _slicedToArray3.default)(_step.value, 2), uid = _step$value[0], node = _step$value[1];

                  cache[uid] = (0, _stringify2.default)(node);
                }
                _context.next = 12;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context['catch'](4);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 12:
                _context.prev = 12;
                _context.prev = 13;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 15:
                _context.prev = 15;

                if (!_didIteratorError) {
                  _context.next = 18;
                  break;
                }

                throw _iteratorError;

              case 18:
                return _context.finish(15);

              case 19:
                return _context.finish(12);

              case 20:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 8, 12, 20], [13,, 15, 19]]);
      }));

      function write(_x) {
        return _ref.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(uid) {
        var value;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                value = this.cache[uid];
                return _context2.abrupt('return', value && JSON.parse(value));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x2) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()
  }]);
  return Storage;
}(); /* eslint-disable require-jsdoc */
/* eslint-env mocha */


describe('A storage plugin', function () {
  var db = void 0,
      storage = void 0;

  beforeEach(function () {
    storage = new Storage();

    db = (0, _index2.default)({
      storage: [storage]
    });
  });

  context('write', function () {
    var write = void 0;

    beforeEach(function () {
      write = (0, _expect.spyOn)(storage, 'write').andCallThrough();
    });

    it('should be given a graph', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var _write$calls$0$argume, graph;

      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return db.write('users', {});

            case 2:

              (0, _expect2.default)(write).toHaveBeenCalled();
              _write$calls$0$argume = (0, _slicedToArray3.default)(write.calls[0].arguments, 1), graph = _write$calls$0$argume[0];

              (0, _expect2.default)(graph).toBeA(_graphCrdt.Graph);

            case 5:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    })));

    it('should contain complete node state', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var _write$calls$1$argume, graph, node;

      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return db.write('state', { original: true });

            case 2:
              _context4.next = 4;
              return db.write('state', { update: true });

            case 4:

              // Assert full in-memory state.
              (0, _expect2.default)(write.calls.length).toBe(2);

              _write$calls$1$argume = (0, _slicedToArray3.default)(write.calls[1].arguments, 1), graph = _write$calls$1$argume[0];
              node = graph.value('state');


              (0, _expect2.default)([].concat((0, _toConsumableArray3.default)(node))).toEqual([['original', true], ['update', true]]);

            case 8:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, undefined);
    })));

    it('should be passed node updates', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      var profile;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return db.write('profile', {
                name: 'Bob Carlson VII'
              });

            case 2:
              profile = _context5.sent;


              (0, _expect2.default)(write.calls.length).toBe(1);
              _context5.next = 6;
              return profile.write('username', 'SuperBob');

            case 6:
              (0, _expect2.default)(write.calls.length).toBe(2);

            case 7:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, undefined);
    })));
  });

  context('read', function () {
    var read = void 0,
        graph = void 0,
        node = void 0;

    beforeEach(function () {
      read = (0, _expect.spyOn)(storage, 'read').andCallThrough();

      graph = new _graphCrdt.Graph();
      node = new _graphCrdt.Node();
    });

    it('should be used to retrieve state', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
      var result;
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              node.merge({ from: 'storage' });
              graph.merge((0, _defineProperty3.default)({}, node, node));

              _context6.next = 4;
              return storage.write(graph);

            case 4:
              _context6.next = 6;
              return db.read(node.toString());

            case 6:
              result = _context6.sent;

              (0, _expect2.default)(read).toHaveBeenCalled();
              (0, _expect2.default)(result).toBeA(_graphCrdt.Node);

              (0, _expect2.default)([].concat((0, _toConsumableArray3.default)(result))).toEqual([['from', 'storage']]);

            case 10:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, undefined);
    })));

    it('should not be called if the value is cached', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7() {
      return _regenerator2.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.next = 2;
              return db.write('stuff', { value: 'probably' });

            case 2:
              _context7.next = 4;
              return db.read('stuff');

            case 4:
              (0, _expect2.default)(read).toNotHaveBeenCalled();

            case 5:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, undefined);
    })));

    it('should cache read results', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
      return _regenerator2.default.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              node.merge({ from: 'storage' });
              graph.merge((0, _defineProperty3.default)({}, node, node));
              _context8.next = 4;
              return storage.write(graph);

            case 4:

              (0, _expect2.default)(read.calls.length).toBe(0);

              // First read.
              _context8.next = 7;
              return db.read(node.toString());

            case 7:
              (0, _expect2.default)(read.calls.length).toBe(1);

              // Second read.
              _context8.next = 10;
              return db.read(node.toString());

            case 10:
              (0, _expect2.default)(read.calls.length).toBe(1);

            case 11:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee8, undefined);
    })));
  });
});