'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _isPromise = require('is-promise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Triggers an asynchronous hook pipeline. Each hook can change
 * the input to the next via the `transform` callback.
 * @param  {Object} pipeline - Describes what hooks to call and how.
 * @param  {Array} pipeline.hooks - A list of functions to call.
 * @param  {Array} pipeline.args - The initial arguments to start with.
 * @return {Promise} - Resolves to the final arguments output.
 */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var hooks = _ref2.hooks,
        args = _ref2.args,
        transform = _ref2.transform;

    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, hook, output;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 3;
            _iterator = (0, _getIterator3.default)(hooks);

          case 5:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 16;
              break;
            }

            hook = _step.value;
            output = hook.call.apply(hook, [this].concat((0, _toConsumableArray3.default)(args)));

            if (!(0, _isPromise2.default)(output)) {
              _context.next = 12;
              break;
            }

            _context.next = 11;
            return output;

          case 11:
            output = _context.sent;

          case 12:

            args = transform(output, args);

          case 13:
            _iteratorNormalCompletion = true;
            _context.next = 5;
            break;

          case 16:
            _context.next = 22;
            break;

          case 18:
            _context.prev = 18;
            _context.t0 = _context['catch'](3);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 22:
            _context.prev = 22;
            _context.prev = 23;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 25:
            _context.prev = 25;

            if (!_didIteratorError) {
              _context.next = 28;
              break;
            }

            throw _iteratorError;

          case 28:
            return _context.finish(25);

          case 29:
            return _context.finish(22);

          case 30:
            return _context.abrupt('return', args);

          case 31:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 18, 22, 30], [23,, 25, 29]]);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();